# Pgcd

def pgcd(a, b):
    while b != 0:
        a, b = b, a % b
    return a

def mod3(s1, s2):
    u1, v1, r1 = s1
    u2, v2, r2 = s2
    q = r1 // r2
    return [u1 - q * u2, v1 - q * v2, r1 - q * r2]

def euclide(a, b):
    s1 = [1, 0, a]
    s2 = [0, 1, b]
    while s2[2] != 0:
        s1, s2 = s2, mod3(s1, s2)
    return s1

# Équation diophantienne de degré 1

def afficher_sol_diophante(a, b, c):
    d = pgcd(a, b)
    if d == 0:
        if c != 0: print('ø')
        else: print('Z x Z')
    elif c % d != 0: print('ø')
    else:
        a, b, c = a // d, b // d, c // d
        u, v, r = euclide(a, b)
        x0, y0 = u * c, v * c
        print('{(%d %+dk, %d %+dk), k \u2208 Z}' % (x0, b, y0, -a))

# Primalité

def plus_petit_diviseur(n):
    p = 2
    while p * p <= n and n % p != 0: p = p + 1
    if p * p > n: return n
    else: return p

def est_premier(n):
    return n > 1 and plus_petit_diviseur(n) == n

# Factorisation

def valuation(n, p):
    nu = 0
    while n % p == 0:
        nu = nu + 1
        n =  n // p
    return nu

def factoriser(n):
    fs = []
    while n != 1:
        p = plus_petit_diviseur(n)
        nu = valuation(n, p)
        fs.append((p, nu))
        n = n // p ** nu
    return fs

# Diviseurs

def diviseurs(n):
    return sorted(diviseurs_aux(factoriser(n)))

def diviseurs_aux(fs):
    if fs == []: return [1]
    else:
        p, nu = fs[0]
        ds1 = diviseurs_aux(fs[1:])
        return [p ** k * d for d in ds1 for k in range(nu + 1)]
